Bug 24857 - Add ability to create "Volumes" for records, and assign items to volumes
Summary: Add ability to create "Volumes" for records, and assign items to volumes
Status: Signed Off
Alias: None
Product: Koha
Classification: Unclassified
Component: Cataloging (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement with 10 votes (vote)
Assignee: Kyle M Hall
QA Contact: Testopia
URL:
Keywords:
Depends on:
Blocks: 24860 26275 26276 26931
  Show dependency treegraph
 
Reported: 2020-03-12 13:38 UTC by Kyle M Hall
Modified: 2020-12-23 02:43 UTC (History)
6 users (show)

See Also:
Change sponsored?: ---
Patch complexity: ---
Text to go in the release notes:
Version(s) released in:


Attachments
Bug 24857: Update Database (8.21 KB, patch)
2020-03-12 16:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Schema files (7.21 KB, patch)
2020-03-12 16:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.83 KB, patch)
2020-03-12 16:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.18 KB, patch)
2020-03-12 16:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.15 KB, patch)
2020-03-12 16:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.61 KB, patch)
2020-03-12 16:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (11.64 KB, patch)
2020-03-12 16:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (14.47 KB, patch)
2020-03-12 16:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.61 KB, patch)
2020-03-12 16:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.39 KB, patch)
2020-03-12 16:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.55 KB, patch)
2020-03-12 16:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.21 KB, patch)
2020-03-24 16:57 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.34 KB, patch)
2020-03-24 16:58 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (2.19 KB, patch)
2020-03-24 16:58 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.83 KB, patch)
2020-03-24 16:58 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.18 KB, patch)
2020-03-24 16:58 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.15 KB, patch)
2020-03-24 16:58 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.61 KB, patch)
2020-03-24 16:58 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (11.64 KB, patch)
2020-03-24 16:58 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (14.47 KB, patch)
2020-03-24 16:58 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.61 KB, patch)
2020-03-24 16:58 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.39 KB, patch)
2020-03-24 16:58 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.55 KB, patch)
2020-03-24 16:58 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.24 KB, patch)
2020-03-24 19:01 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.34 KB, patch)
2020-03-24 19:01 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.83 KB, patch)
2020-03-24 19:01 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.50 KB, patch)
2020-03-24 19:01 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.15 KB, patch)
2020-03-24 19:01 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.61 KB, patch)
2020-03-24 19:01 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (11.64 KB, patch)
2020-03-24 19:01 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (14.50 KB, patch)
2020-03-24 19:01 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.62 KB, patch)
2020-03-24 19:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.42 KB, patch)
2020-03-24 19:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.23 KB, patch)
2020-03-24 19:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.67 KB, patch)
2020-03-24 19:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.24 KB, patch)
2020-03-25 11:01 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.34 KB, patch)
2020-03-25 11:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.83 KB, patch)
2020-03-25 11:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.50 KB, patch)
2020-03-25 11:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.15 KB, patch)
2020-03-25 11:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.61 KB, patch)
2020-03-25 11:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (11.64 KB, patch)
2020-03-25 11:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (14.33 KB, patch)
2020-03-25 11:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.62 KB, patch)
2020-03-25 11:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.42 KB, patch)
2020-03-25 11:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.23 KB, patch)
2020-03-25 11:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.67 KB, patch)
2020-03-25 11:02 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.24 KB, patch)
2020-03-25 16:50 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.34 KB, patch)
2020-03-25 16:50 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.83 KB, patch)
2020-03-25 16:50 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.50 KB, patch)
2020-03-25 16:50 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.15 KB, patch)
2020-03-25 16:50 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.61 KB, patch)
2020-03-25 16:50 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (11.64 KB, patch)
2020-03-25 16:50 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (15.89 KB, patch)
2020-03-25 16:50 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.62 KB, patch)
2020-03-25 16:50 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.40 KB, patch)
2020-03-25 16:50 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.23 KB, patch)
2020-03-25 16:50 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.67 KB, patch)
2020-03-25 16:50 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.17 KB, patch)
2020-03-25 18:29 UTC, Andrew Fuerste-Henry
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.40 KB, patch)
2020-03-25 18:29 UTC, Andrew Fuerste-Henry
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.91 KB, patch)
2020-03-25 18:30 UTC, Andrew Fuerste-Henry
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.55 KB, patch)
2020-03-25 18:30 UTC, Andrew Fuerste-Henry
Details | Diff | Splinter Review
Bug 24857: API spec (24.20 KB, patch)
2020-03-25 18:30 UTC, Andrew Fuerste-Henry
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.67 KB, patch)
2020-03-25 18:30 UTC, Andrew Fuerste-Henry
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (11.70 KB, patch)
2020-03-25 18:30 UTC, Andrew Fuerste-Henry
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (15.95 KB, patch)
2020-03-25 18:30 UTC, Andrew Fuerste-Henry
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.68 KB, patch)
2020-03-25 18:30 UTC, Andrew Fuerste-Henry
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.47 KB, patch)
2020-03-25 18:30 UTC, Andrew Fuerste-Henry
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.28 KB, patch)
2020-03-25 18:30 UTC, Andrew Fuerste-Henry
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.72 KB, patch)
2020-03-25 18:30 UTC, Andrew Fuerste-Henry
Details | Diff | Splinter Review
Bug 24857: Update Database (8.30 KB, patch)
2020-05-15 17:49 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.40 KB, patch)
2020-05-15 17:49 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.89 KB, patch)
2020-05-15 17:49 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.56 KB, patch)
2020-05-15 17:49 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.21 KB, patch)
2020-05-15 17:49 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.67 KB, patch)
2020-05-15 17:49 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (11.71 KB, patch)
2020-05-15 17:49 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (15.94 KB, patch)
2020-05-15 17:49 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.70 KB, patch)
2020-05-15 17:49 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.76 KB, patch)
2020-05-15 17:49 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.34 KB, patch)
2020-05-15 17:49 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.67 KB, patch)
2020-05-15 17:49 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Copy the volume to the item's enumchron (8.45 KB, patch)
2020-05-15 18:40 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add user permission for volumes management (8.95 KB, patch)
2020-05-15 19:13 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.22 KB, patch)
2020-07-09 16:13 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.46 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.96 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.60 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: API spec (24.26 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.72 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (11.76 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (15.99 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.76 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.82 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.37 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.71 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Copy the volume to the item's enumchron (8.50 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Add user permission for volumes management (9.02 KB, patch)
2020-07-09 16:14 UTC, ByWater Sandboxes
Details | Diff | Splinter Review
Bug 24857: Update Database (8.36 KB, patch)
2020-08-18 10:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.46 KB, patch)
2020-08-18 10:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.95 KB, patch)
2020-08-18 10:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.62 KB, patch)
2020-08-18 10:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.26 KB, patch)
2020-08-18 10:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.73 KB, patch)
2020-08-18 10:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (11.76 KB, patch)
2020-08-18 10:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (15.99 KB, patch)
2020-08-18 10:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.71 KB, patch)
2020-08-18 10:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.88 KB, patch)
2020-08-18 10:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.39 KB, patch)
2020-08-18 10:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.72 KB, patch)
2020-08-18 10:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Copy the volume to the item's enumchron (8.52 KB, patch)
2020-08-18 10:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add user permission for volumes management (9.01 KB, patch)
2020-08-18 10:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.36 KB, patch)
2020-08-19 17:34 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.46 KB, patch)
2020-08-19 17:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.95 KB, patch)
2020-08-19 17:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.61 KB, patch)
2020-08-19 17:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.26 KB, patch)
2020-08-19 17:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.73 KB, patch)
2020-08-19 17:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (11.76 KB, patch)
2020-08-19 17:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (15.99 KB, patch)
2020-08-19 17:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.71 KB, patch)
2020-08-19 17:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.88 KB, patch)
2020-08-19 17:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.39 KB, patch)
2020-08-19 17:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.72 KB, patch)
2020-08-19 17:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Copy the volume to the item's enumchron (8.52 KB, patch)
2020-08-19 17:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add user permission for volumes management (9.01 KB, patch)
2020-08-19 17:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix license statements (10.00 KB, patch)
2020-08-19 17:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix POD (2.55 KB, patch)
2020-08-19 17:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add missing filter and move js to footer on additem.tt (1.52 KB, patch)
2020-08-19 17:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix simple-quote string (1.35 KB, patch)
2020-08-19 17:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Remove doubled 'use Koha::Biblio::Volumes' (688 bytes, patch)
2020-08-19 17:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix sorting of new syspref (2.04 KB, patch)
2020-08-19 17:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Change button text from "Create new" to "New volume" (1.21 KB, patch)
2020-08-19 17:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.36 KB, patch)
2020-08-25 14:35 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.46 KB, patch)
2020-08-25 14:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.95 KB, patch)
2020-08-25 14:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.61 KB, patch)
2020-08-25 14:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.26 KB, patch)
2020-08-25 14:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.73 KB, patch)
2020-08-25 14:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (11.76 KB, patch)
2020-08-25 14:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (15.99 KB, patch)
2020-08-25 14:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.70 KB, patch)
2020-08-25 14:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.88 KB, patch)
2020-08-25 14:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.39 KB, patch)
2020-08-25 14:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.72 KB, patch)
2020-08-25 14:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Copy the volume to the item's enumchron (8.60 KB, patch)
2020-08-25 14:36 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add user permission for volumes management (9.01 KB, patch)
2020-08-25 14:37 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix license statements (10.00 KB, patch)
2020-08-25 14:37 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix POD (2.55 KB, patch)
2020-08-25 14:37 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add missing filter and move js to footer on additem.tt (1.52 KB, patch)
2020-08-25 14:37 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix simple-quote string (1.35 KB, patch)
2020-08-25 14:37 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Remove doubled 'use Koha::Biblio::Volumes' (688 bytes, patch)
2020-08-25 14:37 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix sorting of new syspref (2.04 KB, patch)
2020-08-25 14:37 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Change button text from "Create new" to "New volume" (1.21 KB, patch)
2020-08-25 14:37 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.50 KB, patch)
2020-09-09 13:47 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.46 KB, patch)
2020-09-09 13:47 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.95 KB, patch)
2020-09-09 13:47 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.61 KB, patch)
2020-09-09 13:47 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.26 KB, patch)
2020-09-09 13:47 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.73 KB, patch)
2020-09-09 13:47 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (11.76 KB, patch)
2020-09-09 13:47 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (15.99 KB, patch)
2020-09-09 13:47 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.70 KB, patch)
2020-09-09 13:47 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.91 KB, patch)
2020-09-09 13:48 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.39 KB, patch)
2020-09-09 13:48 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Copy the volume to the item's enumchron (8.60 KB, patch)
2020-09-09 13:48 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add user permission for volumes management (9.01 KB, patch)
2020-09-09 13:48 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix license statements (10.00 KB, patch)
2020-09-09 13:48 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix POD (2.55 KB, patch)
2020-09-09 13:48 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add missing filter and move js to footer on additem.tt (1.52 KB, patch)
2020-09-09 13:48 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix simple-quote string (1.35 KB, patch)
2020-09-09 13:48 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Remove doubled 'use Koha::Biblio::Volumes' (688 bytes, patch)
2020-09-09 13:48 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix sorting of new syspref (2.04 KB, patch)
2020-09-09 13:48 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Change button text from "Create new" to "New volume" (1.21 KB, patch)
2020-09-09 13:48 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.61 KB, patch)
2020-09-09 13:48 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: (QA follow-up) Add volume to table settings (3.08 KB, patch)
2020-09-11 10:27 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.50 KB, patch)
2020-09-11 10:53 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.46 KB, patch)
2020-09-11 10:53 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.95 KB, patch)
2020-09-11 10:53 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.61 KB, patch)
2020-09-11 10:53 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.26 KB, patch)
2020-09-11 10:53 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.73 KB, patch)
2020-09-11 10:53 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (12.12 KB, patch)
2020-09-11 10:54 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (15.99 KB, patch)
2020-09-11 10:54 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.70 KB, patch)
2020-09-11 10:54 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.91 KB, patch)
2020-09-11 10:54 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.35 KB, patch)
2020-09-11 10:54 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Copy the volume to the item's enumchron (8.60 KB, patch)
2020-09-11 10:54 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add user permission for volumes management (9.01 KB, patch)
2020-09-11 10:54 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix license statements (10.00 KB, patch)
2020-09-11 10:54 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix POD (2.55 KB, patch)
2020-09-11 10:54 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add missing filter and move js to footer on additem.tt (1.52 KB, patch)
2020-09-11 10:54 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix simple-quote string (1.35 KB, patch)
2020-09-11 10:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Remove doubled 'use Koha::Biblio::Volumes' (688 bytes, patch)
2020-09-11 10:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix sorting of new syspref (2.04 KB, patch)
2020-09-11 10:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Change button text from "Create new" to "New volume" (1.21 KB, patch)
2020-09-11 10:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.61 KB, patch)
2020-09-11 10:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: (QA follow-up) Add volume to table settings (3.08 KB, patch)
2020-09-11 10:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: (QA follow-up) Unit tests (15.16 KB, patch)
2020-09-11 10:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.54 KB, patch)
2020-11-05 19:52 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.54 KB, patch)
2020-11-05 19:54 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.46 KB, patch)
2020-11-05 19:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.95 KB, patch)
2020-11-05 19:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.44 KB, patch)
2020-11-05 19:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.26 KB, patch)
2020-11-05 19:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.73 KB, patch)
2020-11-05 19:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (12.12 KB, patch)
2020-11-05 19:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (15.98 KB, patch)
2020-11-05 19:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.73 KB, patch)
2020-11-05 19:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.86 KB, patch)
2020-11-05 19:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.35 KB, patch)
2020-11-05 19:55 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Copy the volume to the item's enumchron (8.60 KB, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add user permission for volumes management (9.04 KB, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix license statements (10.00 KB, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix POD (2.55 KB, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add missing filter and move js to footer on additem.tt (1.52 KB, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix simple-quote string (1.35 KB, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Remove doubled 'use Koha::Biblio::Volumes' (688 bytes, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix sorting of new syspref (2.09 KB, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Change button text from "Create new" to "New volume" (1.21 KB, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: (QA follow-up) Add volume to table settings (3.08 KB, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: (QA follow-up) Unit tests (15.16 KB, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.61 KB, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: (QA follow-up) Fix unit tests and code for changes in Koha::Item::delete (4.44 KB, patch)
2020-11-05 19:56 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update Database (8.54 KB, patch)
2020-11-05 20:08 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add new Schema files (5.46 KB, patch)
2020-11-05 20:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Koha Object(s) (5.95 KB, patch)
2020-11-05 20:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add Object Methods (2.44 KB, patch)
2020-11-05 20:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: API spec (24.26 KB, patch)
2020-11-05 20:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Koha::Biblio::Volume methods (2.73 KB, patch)
2020-11-05 20:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Implement volume related controllers (12.12 KB, patch)
2020-11-05 20:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add volume management to detail.pl (16.00 KB, patch)
2020-11-05 20:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to attach newly cataloged items to a volume (7.73 KB, patch)
2020-11-05 20:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add ability to manage item's volumes from detail.pl (11.86 KB, patch)
2020-11-05 20:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Delete a volume when the last item on that volume is deleted (1.35 KB, patch)
2020-11-05 20:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Copy the volume to the item's enumchron (8.60 KB, patch)
2020-11-05 20:09 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add user permission for volumes management (9.04 KB, patch)
2020-11-05 20:10 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix license statements (10.00 KB, patch)
2020-11-05 20:10 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix POD (2.55 KB, patch)
2020-11-05 20:10 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Add missing filter and move js to footer on additem.tt (1.52 KB, patch)
2020-11-05 20:10 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix simple-quote string (1.35 KB, patch)
2020-11-05 20:10 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Remove doubled 'use Koha::Biblio::Volumes' (688 bytes, patch)
2020-11-05 20:10 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Fix sorting of new syspref (2.09 KB, patch)
2020-11-05 20:10 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Change button text from "Create new" to "New volume" (1.21 KB, patch)
2020-11-05 20:10 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: (QA follow-up) Add volume to table settings (3.08 KB, patch)
2020-11-05 20:10 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: (QA follow-up) Unit tests (15.16 KB, patch)
2020-11-05 20:10 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: Update existing Schema files [DO NOT PUSH] (4.61 KB, patch)
2020-11-05 20:10 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24857: (QA follow-up) Fix unit tests and code for changes in Koha::Item::delete (4.44 KB, patch)
2020-11-05 20:10 UTC, Kyle M Hall
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Kyle M Hall 2020-03-12 13:38:07 UTC
We have a partner that needs Volume Level Holds. This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level, with items being optionally assigned to a given volume. This facilitates the ability to place holds at a volume level, rather than on a specific item or any available item on a record.

This but is to add just the volume management itself, which no functionality tied to volumes.
Comment 1 Kyle M Hall 2020-03-12 16:09:04 UTC
Created attachment 100652 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items
Comment 2 Kyle M Hall 2020-03-12 16:09:15 UTC
Created attachment 100653 [details] [review]
Bug 24857: Add Schema files
Comment 3 Kyle M Hall 2020-03-12 16:09:18 UTC
Created attachment 100654 [details] [review]
Bug 24857: Add Koha Object(s)
Comment 4 Kyle M Hall 2020-03-12 16:09:20 UTC
Created attachment 100655 [details] [review]
Bug 24857: Add Object Methods
Comment 5 Kyle M Hall 2020-03-12 16:09:23 UTC
Created attachment 100656 [details] [review]
Bug 24857: API spec
Comment 6 Kyle M Hall 2020-03-12 16:09:25 UTC
Created attachment 100657 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)
Comment 7 Kyle M Hall 2020-03-12 16:09:28 UTC
Created attachment 100658 [details] [review]
Bug 24857: Implement volume related controllers
Comment 8 Kyle M Hall 2020-03-12 16:09:30 UTC
Created attachment 100659 [details] [review]
Bug 24857: Add volume management to detail.pl
Comment 9 Kyle M Hall 2020-03-12 16:09:33 UTC
Created attachment 100660 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume
Comment 10 Kyle M Hall 2020-03-12 16:09:36 UTC
Created attachment 100661 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl
Comment 11 Kyle M Hall 2020-03-12 16:09:39 UTC
Created attachment 100662 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted
Comment 12 Kyle M Hall 2020-03-24 16:57:54 UTC
Created attachment 101637 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items
Comment 13 Kyle M Hall 2020-03-24 16:58:06 UTC
Created attachment 101638 [details] [review]
Bug 24857: Add new Schema files
Comment 14 Kyle M Hall 2020-03-24 16:58:09 UTC
Created attachment 101639 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]
Comment 15 Kyle M Hall 2020-03-24 16:58:13 UTC
Created attachment 101640 [details] [review]
Bug 24857: Add Koha Object(s)
Comment 16 Kyle M Hall 2020-03-24 16:58:17 UTC
Created attachment 101641 [details] [review]
Bug 24857: Add Object Methods
Comment 17 Kyle M Hall 2020-03-24 16:58:21 UTC
Created attachment 101642 [details] [review]
Bug 24857: API spec
Comment 18 Kyle M Hall 2020-03-24 16:58:24 UTC
Created attachment 101643 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)
Comment 19 Kyle M Hall 2020-03-24 16:58:28 UTC
Created attachment 101644 [details] [review]
Bug 24857: Implement volume related controllers
Comment 20 Kyle M Hall 2020-03-24 16:58:33 UTC
Created attachment 101645 [details] [review]
Bug 24857: Add volume management to detail.pl
Comment 21 Kyle M Hall 2020-03-24 16:58:37 UTC
Created attachment 101646 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume
Comment 22 Kyle M Hall 2020-03-24 16:58:41 UTC
Created attachment 101647 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl
Comment 23 Kyle M Hall 2020-03-24 16:58:44 UTC
Created attachment 101648 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted
Comment 24 Kyle M Hall 2020-03-24 19:01:26 UTC
Created attachment 101650 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items
Comment 25 Kyle M Hall 2020-03-24 19:01:36 UTC
Created attachment 101651 [details] [review]
Bug 24857: Add new Schema files
Comment 26 Kyle M Hall 2020-03-24 19:01:40 UTC
Created attachment 101652 [details] [review]
Bug 24857: Add Koha Object(s)
Comment 27 Kyle M Hall 2020-03-24 19:01:43 UTC
Created attachment 101653 [details] [review]
Bug 24857: Add Object Methods
Comment 28 Kyle M Hall 2020-03-24 19:01:47 UTC
Created attachment 101654 [details] [review]
Bug 24857: API spec
Comment 29 Kyle M Hall 2020-03-24 19:01:50 UTC
Created attachment 101655 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)
Comment 30 Kyle M Hall 2020-03-24 19:01:54 UTC
Created attachment 101656 [details] [review]
Bug 24857: Implement volume related controllers
Comment 31 Kyle M Hall 2020-03-24 19:01:57 UTC
Created attachment 101657 [details] [review]
Bug 24857: Add volume management to detail.pl
Comment 32 Kyle M Hall 2020-03-24 19:02:00 UTC
Created attachment 101658 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume
Comment 33 Kyle M Hall 2020-03-24 19:02:03 UTC
Created attachment 101659 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl
Comment 34 Kyle M Hall 2020-03-24 19:02:06 UTC
Created attachment 101660 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted
Comment 35 Kyle M Hall 2020-03-24 19:02:10 UTC
Created attachment 101661 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]
Comment 36 Kyle M Hall 2020-03-25 11:01:58 UTC
Created attachment 101670 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items
Comment 37 Kyle M Hall 2020-03-25 11:02:08 UTC
Created attachment 101671 [details] [review]
Bug 24857: Add new Schema files
Comment 38 Kyle M Hall 2020-03-25 11:02:11 UTC
Created attachment 101672 [details] [review]
Bug 24857: Add Koha Object(s)
Comment 39 Kyle M Hall 2020-03-25 11:02:15 UTC
Created attachment 101673 [details] [review]
Bug 24857: Add Object Methods
Comment 40 Kyle M Hall 2020-03-25 11:02:18 UTC
Created attachment 101674 [details] [review]
Bug 24857: API spec
Comment 41 Kyle M Hall 2020-03-25 11:02:21 UTC
Created attachment 101675 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)
Comment 42 Kyle M Hall 2020-03-25 11:02:25 UTC
Created attachment 101676 [details] [review]
Bug 24857: Implement volume related controllers
Comment 43 Kyle M Hall 2020-03-25 11:02:28 UTC
Created attachment 101677 [details] [review]
Bug 24857: Add volume management to detail.pl
Comment 44 Kyle M Hall 2020-03-25 11:02:31 UTC
Created attachment 101678 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume
Comment 45 Kyle M Hall 2020-03-25 11:02:34 UTC
Created attachment 101679 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl
Comment 46 Kyle M Hall 2020-03-25 11:02:37 UTC
Created attachment 101680 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted
Comment 47 Kyle M Hall 2020-03-25 11:02:40 UTC
Created attachment 101681 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]
Comment 48 Andrew Fuerste-Henry 2020-03-25 13:21:03 UTC
Getting an ISE because volume info is not cleared from items when volume is deleted

-add items to volume
-delete volume
-see that items still show as in deleted volume
-select items, see you still have volume-related links even though there are no volumes
-click "add/modify volume" and receive ISE
Comment 49 Kyle M Hall 2020-03-25 16:50:03 UTC
Created attachment 101730 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items
Comment 50 Kyle M Hall 2020-03-25 16:50:15 UTC
Created attachment 101731 [details] [review]
Bug 24857: Add new Schema files
Comment 51 Kyle M Hall 2020-03-25 16:50:19 UTC
Created attachment 101732 [details] [review]
Bug 24857: Add Koha Object(s)
Comment 52 Kyle M Hall 2020-03-25 16:50:22 UTC
Created attachment 101733 [details] [review]
Bug 24857: Add Object Methods
Comment 53 Kyle M Hall 2020-03-25 16:50:26 UTC
Created attachment 101734 [details] [review]
Bug 24857: API spec
Comment 54 Kyle M Hall 2020-03-25 16:50:30 UTC
Created attachment 101735 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)
Comment 55 Kyle M Hall 2020-03-25 16:50:33 UTC
Created attachment 101736 [details] [review]
Bug 24857: Implement volume related controllers
Comment 56 Kyle M Hall 2020-03-25 16:50:37 UTC
Created attachment 101737 [details] [review]
Bug 24857: Add volume management to detail.pl
Comment 57 Kyle M Hall 2020-03-25 16:50:41 UTC
Created attachment 101738 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume
Comment 58 Kyle M Hall 2020-03-25 16:50:44 UTC
Created attachment 101739 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl
Comment 59 Kyle M Hall 2020-03-25 16:50:47 UTC
Created attachment 101740 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted
Comment 60 Kyle M Hall 2020-03-25 16:50:51 UTC
Created attachment 101741 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]
Comment 61 Andrew Fuerste-Henry 2020-03-25 18:29:53 UTC
Created attachment 101752 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 62 Andrew Fuerste-Henry 2020-03-25 18:29:56 UTC
Created attachment 101753 [details] [review]
Bug 24857: Add new Schema files

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 63 Andrew Fuerste-Henry 2020-03-25 18:30:00 UTC
Created attachment 101754 [details] [review]
Bug 24857: Add Koha Object(s)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 64 Andrew Fuerste-Henry 2020-03-25 18:30:03 UTC
Created attachment 101755 [details] [review]
Bug 24857: Add Object Methods

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 65 Andrew Fuerste-Henry 2020-03-25 18:30:07 UTC
Created attachment 101756 [details] [review]
Bug 24857: API spec

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 66 Andrew Fuerste-Henry 2020-03-25 18:30:10 UTC
Created attachment 101757 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 67 Andrew Fuerste-Henry 2020-03-25 18:30:13 UTC
Created attachment 101758 [details] [review]
Bug 24857: Implement volume related controllers

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 68 Andrew Fuerste-Henry 2020-03-25 18:30:17 UTC
Created attachment 101759 [details] [review]
Bug 24857: Add volume management to detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 69 Andrew Fuerste-Henry 2020-03-25 18:30:20 UTC
Created attachment 101760 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 70 Andrew Fuerste-Henry 2020-03-25 18:30:24 UTC
Created attachment 101761 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 71 Andrew Fuerste-Henry 2020-03-25 18:30:27 UTC
Created attachment 101762 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 72 Andrew Fuerste-Henry 2020-03-25 18:30:30 UTC
Created attachment 101763 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 73 David Cook 2020-03-26 00:22:06 UTC
This sounds odd. What's a volume mean in this context?
Comment 74 Andrew Fuerste-Henry 2020-03-26 12:27:59 UTC
A volume is a grouping of items within a bib. See bug 24860 for one implementation (patrons can place hold on a volume, get first available item within that volume). Imagine, say, a bib containing multiple copies of a multi-volume series. Patron wants whichever copy of Book 1 comes in first.
Comment 75 Laura Horgan 2020-03-26 17:42:42 UTC
When will this be added to the system and will ther be a way to identify and possibly migrate or create volumes for items in the system cuurently
Comment 76 Katrin Fischer 2020-03-26 21:01:32 UTC
Could this also be used in context of bound serials (all issues of a year bound into one volume)?
Comment 77 Andrew Fuerste-Henry 2020-03-26 21:09:55 UTC
Laura - It's hard to say when this will be in Koha, as it has not yet gone through QA. This patch doesn't include a mechanism to automatically assign items to volumes, but existing items can be added to volumes manually.

Katrin - Yes, absolutely! I can see ways in which defining volumes of periodicals would be useful. Though the only functionality beyond the creation of a volume that's currently being worked on is that in bug 24860.
Comment 78 David Cook 2020-03-26 22:11:58 UTC
(In reply to Andrew Fuerste-Henry from comment #74)
> A volume is a grouping of items within a bib. See bug 24860 for one
> implementation (patrons can place hold on a volume, get first available item
> within that volume). Imagine, say, a bib containing multiple copies of a
> multi-volume series. Patron wants whichever copy of Book 1 comes in first.

That's interesting. I wonder if we should use more generic terminology like "item_group" instead of "volume". Perhaps each group could have a translatable label assigned so you could choose "Volume", "Kit", etc. 

This might be useful for libraries that provide kits, toy bags, computers (with peripherals). Individual pieces could be barcoded and be items in their own right, but be grouped together.
Comment 79 Laura Horgan 2020-03-26 23:12:41 UTC
In our last system it was called parts and was used for books dvds kits, etc
Comment 80 Andrew Fuerste-Henry 2020-03-27 16:00:33 UTC
Y'all might have a look at bug 24023, which adds a way to group items to check out all together.
Comment 81 Kyle M Hall 2020-05-15 17:49:03 UTC
Created attachment 104952 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 82 Kyle M Hall 2020-05-15 17:49:15 UTC
Created attachment 104953 [details] [review]
Bug 24857: Add new Schema files

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 83 Kyle M Hall 2020-05-15 17:49:19 UTC
Created attachment 104954 [details] [review]
Bug 24857: Add Koha Object(s)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 84 Kyle M Hall 2020-05-15 17:49:23 UTC
Created attachment 104955 [details] [review]
Bug 24857: Add Object Methods

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 85 Kyle M Hall 2020-05-15 17:49:27 UTC
Created attachment 104956 [details] [review]
Bug 24857: API spec

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 86 Kyle M Hall 2020-05-15 17:49:31 UTC
Created attachment 104957 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 87 Kyle M Hall 2020-05-15 17:49:35 UTC
Created attachment 104958 [details] [review]
Bug 24857: Implement volume related controllers

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 88 Kyle M Hall 2020-05-15 17:49:39 UTC
Created attachment 104959 [details] [review]
Bug 24857: Add volume management to detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 89 Kyle M Hall 2020-05-15 17:49:43 UTC
Created attachment 104960 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 90 Kyle M Hall 2020-05-15 17:49:48 UTC
Created attachment 104961 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 91 Kyle M Hall 2020-05-15 17:49:52 UTC
Created attachment 104962 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>
Comment 92 Kyle M Hall 2020-05-15 17:49:56 UTC
Created attachment 104963 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]
Comment 93 Laura Horgan 2020-05-15 17:57:34 UTC
I see this was signed off... What version of Koha will it be available?  Not sure if there is somewhere I need to look to see this information... If so please let me know so I won't have to ask this question again.  Thanks in advance
Comment 94 Kyle M Hall 2020-05-15 18:40:32 UTC
Created attachment 104964 [details] [review]
Bug 24857: Copy the volume to the item's enumchron
Comment 95 Kyle M Hall 2020-05-15 19:13:51 UTC
Created attachment 104966 [details] [review]
Bug 24857: Add user permission for volumes management
Comment 96 Katrin Fischer 2020-05-16 10:37:09 UTC
(In reply to Laura Horgan from comment #93)
> I see this was signed off... What version of Koha will it be available?  Not
> sure if there is somewhere I need to look to see this information... If so
> please let me know so I won't have to ask this question again.  Thanks in
> advance

Hi Laura, after sign off this still needs to go through QA. For 20.05 it's too late, as we have already entered 'feature freeze' (focusing on bug fixing and stabilizing) and 'string freeze' (no GUI changes for translations to catch up) for this release. The next one this could be released with is 22.11. Koha doesn't do road maps, but for every version we include what it's ready on time. So the bug and the status is the best way to see what's going on.
Comment 97 ByWater Sandboxes 2020-07-09 16:13:57 UTC
Created attachment 106728 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 98 ByWater Sandboxes 2020-07-09 16:14:00 UTC
Created attachment 106729 [details] [review]
Bug 24857: Add new Schema files

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 99 ByWater Sandboxes 2020-07-09 16:14:04 UTC
Created attachment 106730 [details] [review]
Bug 24857: Add Koha Object(s)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 100 ByWater Sandboxes 2020-07-09 16:14:07 UTC
Created attachment 106731 [details] [review]
Bug 24857: Add Object Methods

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 101 ByWater Sandboxes 2020-07-09 16:14:10 UTC
Created attachment 106732 [details] [review]
Bug 24857: API spec

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 102 ByWater Sandboxes 2020-07-09 16:14:13 UTC
Created attachment 106733 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 103 ByWater Sandboxes 2020-07-09 16:14:16 UTC
Created attachment 106734 [details] [review]
Bug 24857: Implement volume related controllers

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 104 ByWater Sandboxes 2020-07-09 16:14:19 UTC
Created attachment 106735 [details] [review]
Bug 24857: Add volume management to detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 105 ByWater Sandboxes 2020-07-09 16:14:22 UTC
Created attachment 106736 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 106 ByWater Sandboxes 2020-07-09 16:14:25 UTC
Created attachment 106737 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 107 ByWater Sandboxes 2020-07-09 16:14:28 UTC
Created attachment 106738 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 108 ByWater Sandboxes 2020-07-09 16:14:32 UTC
Created attachment 106739 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 109 ByWater Sandboxes 2020-07-09 16:14:35 UTC
Created attachment 106740 [details] [review]
Bug 24857: Copy the volume to the item's enumchron

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 110 ByWater Sandboxes 2020-07-09 16:14:38 UTC
Created attachment 106741 [details] [review]
Bug 24857: Add user permission for volumes management

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 111 Katrin Fischer 2020-08-16 21:56:12 UTC
Patches don't apply cleanly right now, can you please rebase? 

Apply? [(y)es, (n)o, (i)nteractive] y
Applying: Bug 24857: Update Database
Applying: Bug 24857: Add new Schema files
Applying: Bug 24857: Add Koha Object(s)
Applying: Bug 24857: Add Object Methods
Applying: Bug 24857: API spec
Applying: Bug 24857: Koha::Biblio::Volume methods
Applying: Bug 24857: Implement volume related controllers
Applying: Bug 24857: Add volume management to detail.pl
Applying: Bug 24857: Add ability to attach newly cataloged items to a volume
Applying: Bug 24857: Add ability to manage item's volumes from detail.pl
.git/rebase-apply/patch:121: trailing whitespace.
if($query->cookie("holdfor")){ 
error: sha1 information is lacking or useless (koha-tmpl/intranet-tmpl/prog/en/modules/catalogue/detail.tt).
error: could not build fake ancestor
Patch failed at 0001 Bug 24857: Add ability to manage item's volumes from detail.pl
The copy of the patch that failed is found in: .git/rebase-apply/patch
When you have resolved this problem run "git bz apply --continue".
If you would prefer to skip this patch, instead run "git bz apply --skip".
To restore the original branch and stop patching run "git bz apply --abort".
Patch left in /tmp/Bug-24857-Add-ability-to-manage-items-volumes-from-GJYBG0.patch
Comment 112 Kyle M Hall 2020-08-18 10:55:44 UTC
Created attachment 108443 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 113 Kyle M Hall 2020-08-18 10:55:58 UTC
Created attachment 108444 [details] [review]
Bug 24857: Add new Schema files

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 114 Kyle M Hall 2020-08-18 10:56:02 UTC
Created attachment 108445 [details] [review]
Bug 24857: Add Koha Object(s)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 115 Kyle M Hall 2020-08-18 10:56:07 UTC
Created attachment 108446 [details] [review]
Bug 24857: Add Object Methods

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 116 Kyle M Hall 2020-08-18 10:56:12 UTC
Created attachment 108447 [details] [review]
Bug 24857: API spec

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 117 Kyle M Hall 2020-08-18 10:56:16 UTC
Created attachment 108448 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 118 Kyle M Hall 2020-08-18 10:56:22 UTC
Created attachment 108449 [details] [review]
Bug 24857: Implement volume related controllers

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 119 Kyle M Hall 2020-08-18 10:56:26 UTC
Created attachment 108450 [details] [review]
Bug 24857: Add volume management to detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 120 Kyle M Hall 2020-08-18 10:56:30 UTC
Created attachment 108451 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 121 Kyle M Hall 2020-08-18 10:56:35 UTC
Created attachment 108452 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 122 Kyle M Hall 2020-08-18 10:56:40 UTC
Created attachment 108453 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 123 Kyle M Hall 2020-08-18 10:56:44 UTC
Created attachment 108454 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 124 Kyle M Hall 2020-08-18 10:56:49 UTC
Created attachment 108455 [details] [review]
Bug 24857: Copy the volume to the item's enumchron

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 125 Kyle M Hall 2020-08-18 10:56:53 UTC
Created attachment 108456 [details] [review]
Bug 24857: Add user permission for volumes management

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 126 Katrin Fischer 2020-08-18 23:25:20 UTC
This one is a little scary already, but going in for a first review :)

1) QA script

Several issues found, please fix:

 FAIL	Koha/Biblio/Volume.pm
   FAIL	  forbidden patterns
		forbidden pattern: Incorrect license statement (using postal address), may be a false positive if the file is coming from outside Koha (bug 24545) (line 16)

 FAIL	Koha/Biblio/Volume/Item.pm
   FAIL	  forbidden patterns
		forbidden pattern: Incorrect license statement (using postal address), may be a false positive if the file is coming from outside Koha (bug 24545) (line 16)
   FAIL	  pod
		*** WARNING: 
		empty section in previous paragraph
		 
		 in file Koha/Biblio/Volume/Item.pm

 FAIL	Koha/Biblio/Volume/Items.pm
   FAIL	  forbidden patterns
		forbidden pattern: Incorrect license statement (using postal address), may be a false positive if the file is coming from outside Koha (bug 24545) (line 16)
   FAIL	  pod
		*** WARNING: 
		empty section in previous paragraph
		 
		 in file Koha/Biblio/Volume/Items.pm

 FAIL	Koha/Biblio/Volumes.pm
   FAIL	  forbidden patterns
		forbidden pattern: Incorrect license statement (using postal address), may be a false positive if the file is coming from outside Koha (bug 24545) (line 16)
   FAIL	  pod
		*** WARNING: 
		empty section in previous paragraph
		 
		 in file Koha/Biblio/Volumes.pm

 FAIL	Koha/REST/V1/Biblios/Volumes.pm
   FAIL	  forbidden patterns
		forbidden pattern: Incorrect license statement (using postal address), may be a false positive if the file is coming from outside Koha (bug 24545) (line 16)

 FAIL	Koha/REST/V1/Biblios/Volumes/Items.pm
   FAIL	  forbidden patterns
		forbidden pattern: Incorrect license statement (using postal address), may be a false positive if the file is coming from outside Koha (bug 24545) (line 16)

 FAIL	Koha/Schema/Result/Volume.pm
   FAIL	  pod coverage
		POD is missing for koha_object_class
		POD is missing for koha_objects_class

 FAIL	Koha/Schema/Result/VolumeItem.pm
   FAIL	  pod coverage
		POD is missing for koha_object_class
		POD is missing for koha_objects_class

 FAIL	koha-tmpl/intranet-tmpl/prog/en/modules/catalogue/detail.tt
   FAIL	  forbidden patterns
		forbidden pattern: simple-quote string (line 1446)


 FAIL	koha-tmpl/intranet-tmpl/prog/en/modules/cataloguing/additem.tt
   FAIL	  filters
		missing_filter at line 20 (  var has_volumes = [% volumes.count %];)
   FAIL	  js_in_body


2) Doubled up use statement in Biblio.pm

+use Koha::Biblio::Volumes;
+use Koha::Biblio::Volumes;

3) REST API

I'd love to have Tomas take a look on the REST API bits here. 

4) sysprefs.sql

After all the use statements were so nicely alphabetically resorted, THIS?

+('EnableVolumes','0','','Enable volumes feature','YesNo'),
 ('viewISBD','1','','Allow display of ISBD view of bibiographic records','YesNo'),

;)

5) Pref (question)

Enable|Don't enable
volumes feature to allow collecting groups of items on a record into volumes.

Does it mean the items have to be from the same record or could they be from different ones?

6) Table configuration

The new volumn column on the holdings table needs to be added to the table configuration options.

7) GUI

"Create new" on the items table would work nicer as "Create new volume" or "New volume" to give context to translators and for better accessibility.

Future improvements:
It might be nice to offer a kind of grouped view for the items in volumes... but I am not sure yet how this would work best. 
It might be nice to show the volumes in the OPAC as well.

8) Use case and future plans?

Can you tell a bit about in what context or use case this partner is using this? Serials?
Comment 127 Katrin Fischer 2020-08-18 23:31:01 UTC
Hm, I've checked the test plan on the dependent bug now too and am still a little confused about the use case for this.

Reading "volume" made me think of something that would be used for serial issues bound together into one volume (serials, binding) But this doesn't seem to be the case with how the volume hold feature works.

Does this more work like a "Hold group" maybe? One item out of the group appears to satisfy the hold - so maybe "Group" would be a better word to describe the idea?
Comment 128 Kyle M Hall 2020-08-19 17:34:59 UTC
Created attachment 108666 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 129 Kyle M Hall 2020-08-19 17:35:12 UTC
Created attachment 108667 [details] [review]
Bug 24857: Add new Schema files

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 130 Kyle M Hall 2020-08-19 17:35:17 UTC
Created attachment 108668 [details] [review]
Bug 24857: Add Koha Object(s)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 131 Kyle M Hall 2020-08-19 17:35:21 UTC
Created attachment 108669 [details] [review]
Bug 24857: Add Object Methods

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 132 Kyle M Hall 2020-08-19 17:35:25 UTC
Created attachment 108670 [details] [review]
Bug 24857: API spec

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 133 Kyle M Hall 2020-08-19 17:35:29 UTC
Created attachment 108671 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 134 Kyle M Hall 2020-08-19 17:35:34 UTC
Created attachment 108672 [details] [review]
Bug 24857: Implement volume related controllers

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 135 Kyle M Hall 2020-08-19 17:35:38 UTC
Created attachment 108673 [details] [review]
Bug 24857: Add volume management to detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 136 Kyle M Hall 2020-08-19 17:35:42 UTC
Created attachment 108674 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 137 Kyle M Hall 2020-08-19 17:35:47 UTC
Created attachment 108675 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 138 Kyle M Hall 2020-08-19 17:35:51 UTC
Created attachment 108676 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 139 Kyle M Hall 2020-08-19 17:35:55 UTC
Created attachment 108677 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 140 Kyle M Hall 2020-08-19 17:35:59 UTC
Created attachment 108678 [details] [review]
Bug 24857: Copy the volume to the item's enumchron

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 141 Kyle M Hall 2020-08-19 17:36:03 UTC
Created attachment 108679 [details] [review]
Bug 24857: Add user permission for volumes management

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 142 Kyle M Hall 2020-08-19 17:36:07 UTC
Created attachment 108680 [details] [review]
Bug 24857: Fix license statements
Comment 143 Kyle M Hall 2020-08-19 17:36:11 UTC
Created attachment 108681 [details] [review]
Bug 24857: Fix POD
Comment 144 Kyle M Hall 2020-08-19 17:36:16 UTC
Created attachment 108682 [details] [review]
Bug 24857: Add missing filter and move js to footer on additem.tt
Comment 145 Kyle M Hall 2020-08-19 17:36:21 UTC
Created attachment 108683 [details] [review]
Bug 24857: Fix simple-quote string
Comment 146 Kyle M Hall 2020-08-19 17:36:25 UTC
Created attachment 108684 [details] [review]
Bug 24857: Remove doubled 'use Koha::Biblio::Volumes'
Comment 147 Kyle M Hall 2020-08-19 17:36:29 UTC
Created attachment 108685 [details] [review]
Bug 24857: Fix sorting of new syspref
Comment 148 Kyle M Hall 2020-08-19 17:36:34 UTC
Created attachment 108686 [details] [review]
Bug 24857: Change button text from "Create new" to "New volume"
Comment 149 Kyle M Hall 2020-08-19 17:43:44 UTC
(In reply to Katrin Fischer from comment #126)
> This one is a little scary already, but going in for a first review :)
> 
> 1) QA script
Fixed!

> 2) Doubled up use statement in Biblio.pm
 
Fixed!
 
> 3) REST API
> 
> I'd love to have Tomas take a look on the REST API bits here. 

I'll ask Tomas to take a look!

> 
> 4) sysprefs.sql

Fixed!

> 
> 5) Pref (question)
> 
> Enable|Don't enable
> volumes feature to allow collecting groups of items on a record into volumes.
> 
> Does it mean the items have to be from the same record or could they be from
> different ones?

We decided early on that volumes would have contain only items within the same record.

> 6) Table configuration
> 
> The new volumn column on the holdings table needs to be added to the table
> configuration options.

This table is not a datatable so that doesn't really apply.

> 7) GUI
> 
> "Create new" on the items table would work nicer as "Create new volume" or
> "New volume" to give context to translators and for better accessibility.

Fixed!
 
> Future improvements:
> It might be nice to offer a kind of grouped view for the items in volumes...
> but I am not sure yet how this would work best. 
> It might be nice to show the volumes in the OPAC as well.

Agreed. If volume management turns out to be popular, that would be an easy extension to this work.
 
> 8) Use case and future plans?
> 
> Can you tell a bit about in what context or use case this partner is using
> this? Serials?

Our current and only use case at this time is for volume level holds. Some libraries keep different volumes on the same record ( imagine different seasons of a TV series ). In these cases, a bib level hold won't work if you only want Season 1, but if there are 3 copies of season one, you wouldn't want an item level hold either. Volume level holds solve this problem.
Comment 150 Kyle M Hall 2020-08-19 17:45:38 UTC
(In reply to Katrin Fischer from comment #127)
> Hm, I've checked the test plan on the dependent bug now too and am still a
> little confused about the use case for this.
> 
> Reading "volume" made me think of something that would be used for serial
> issues bound together into one volume (serials, binding) But this doesn't
> seem to be the case with how the volume hold feature works.

That is correct. The term volume is used here because that is what most if not all other ILSs use.

> Does this more work like a "Hold group" maybe? One item out of the group
> appears to satisfy the hold - so maybe "Group" would be a better word to
> describe the idea?

You are correct! I described it in a bit more detail in my previous comment.
Comment 151 Katrin Fischer 2020-08-22 10:36:31 UTC
Hi Kyle,

>> 3) REST API
>> 
>> I'd love to have Tomas take a look on the REST API bits here. 

>I'll ask Tomas to take a look!

Waiting for Tomas to comment then :)


>> 6) Table configuration
>> 
>> The new volumn column on the holdings table needs to be added to the table
>> configuration options.

>This table is not a datatable so that doesn't really apply.

That one is a misunderstanding I think: The items table on the detail page is controlled by the table configuration settings and the volume column appears there as a new column.

Table configuration > catalog > holdings_table


9) Unit tests

I am a quite suspicious that there are no unit tests at all... We have new things in Biblio.pm, Items.pm and also new modules.
Comment 152 Kyle M Hall 2020-08-25 14:35:49 UTC
Created attachment 109074 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 153 Kyle M Hall 2020-08-25 14:36:03 UTC
Created attachment 109075 [details] [review]
Bug 24857: Add new Schema files

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 154 Kyle M Hall 2020-08-25 14:36:08 UTC
Created attachment 109076 [details] [review]
Bug 24857: Add Koha Object(s)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 155 Kyle M Hall 2020-08-25 14:36:13 UTC
Created attachment 109077 [details] [review]
Bug 24857: Add Object Methods

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 156 Kyle M Hall 2020-08-25 14:36:18 UTC
Created attachment 109078 [details] [review]
Bug 24857: API spec

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 157 Kyle M Hall 2020-08-25 14:36:23 UTC
Created attachment 109079 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 158 Kyle M Hall 2020-08-25 14:36:28 UTC
Created attachment 109080 [details] [review]
Bug 24857: Implement volume related controllers

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 159 Kyle M Hall 2020-08-25 14:36:33 UTC
Created attachment 109081 [details] [review]
Bug 24857: Add volume management to detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 160 Kyle M Hall 2020-08-25 14:36:38 UTC
Created attachment 109082 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 161 Kyle M Hall 2020-08-25 14:36:43 UTC
Created attachment 109083 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 162 Kyle M Hall 2020-08-25 14:36:47 UTC
Created attachment 109084 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 163 Kyle M Hall 2020-08-25 14:36:52 UTC
Created attachment 109085 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 164 Kyle M Hall 2020-08-25 14:36:57 UTC
Created attachment 109086 [details] [review]
Bug 24857: Copy the volume to the item's enumchron

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 165 Kyle M Hall 2020-08-25 14:37:01 UTC
Created attachment 109087 [details] [review]
Bug 24857: Add user permission for volumes management

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 166 Kyle M Hall 2020-08-25 14:37:06 UTC
Created attachment 109088 [details] [review]
Bug 24857: Fix license statements
Comment 167 Kyle M Hall 2020-08-25 14:37:10 UTC
Created attachment 109089 [details] [review]
Bug 24857: Fix POD
Comment 168 Kyle M Hall 2020-08-25 14:37:15 UTC
Created attachment 109090 [details] [review]
Bug 24857: Add missing filter and move js to footer on additem.tt
Comment 169 Kyle M Hall 2020-08-25 14:37:18 UTC
Created attachment 109091 [details] [review]
Bug 24857: Fix simple-quote string
Comment 170 Kyle M Hall 2020-08-25 14:37:23 UTC
Created attachment 109092 [details] [review]
Bug 24857: Remove doubled 'use Koha::Biblio::Volumes'
Comment 171 Kyle M Hall 2020-08-25 14:37:27 UTC
Created attachment 109093 [details] [review]
Bug 24857: Fix sorting of new syspref
Comment 172 Kyle M Hall 2020-08-25 14:37:31 UTC
Created attachment 109094 [details] [review]
Bug 24857: Change button text from "Create new" to "New volume"
Comment 173 Kyle M Hall 2020-08-25 14:41:15 UTC
(In reply to Katrin Fischer from comment #151)
> Hi Kyle,
> 
> >> 3) REST API
> >> 
> >> I'd love to have Tomas take a look on the REST API bits here. 
> 
> >I'll ask Tomas to take a look!
> 
> Waiting for Tomas to comment then :)
> 
> 
> >> 6) Table configuration
> >> 
> >> The new volumn column on the holdings table needs to be added to the table
> >> configuration options.
> 
> >This table is not a datatable so that doesn't really apply.
> 
> That one is a misunderstanding I think: The items table on the detail page
> is controlled by the table configuration settings and the volume column
> appears there as a new column.
> 
> Table configuration > catalog > holdings_table

I'll take a look!

> 
> 
> 9) Unit tests
> 
> I am a quite suspicious that there are no unit tests at all... We have new
> things in Biblio.pm, Items.pm and also new modules.

I'll add unit tests!
Comment 174 Kyle M Hall 2020-09-09 13:47:10 UTC
Created attachment 109795 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 175 Kyle M Hall 2020-09-09 13:47:24 UTC
Created attachment 109796 [details] [review]
Bug 24857: Add new Schema files

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 176 Kyle M Hall 2020-09-09 13:47:29 UTC
Created attachment 109797 [details] [review]
Bug 24857: Add Koha Object(s)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 177 Kyle M Hall 2020-09-09 13:47:34 UTC
Created attachment 109798 [details] [review]
Bug 24857: Add Object Methods

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 178 Kyle M Hall 2020-09-09 13:47:39 UTC
Created attachment 109799 [details] [review]
Bug 24857: API spec

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 179 Kyle M Hall 2020-09-09 13:47:44 UTC
Created attachment 109800 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 180 Kyle M Hall 2020-09-09 13:47:49 UTC
Created attachment 109801 [details] [review]
Bug 24857: Implement volume related controllers

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 181 Kyle M Hall 2020-09-09 13:47:53 UTC
Created attachment 109802 [details] [review]
Bug 24857: Add volume management to detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 182 Kyle M Hall 2020-09-09 13:47:58 UTC
Created attachment 109803 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 183 Kyle M Hall 2020-09-09 13:48:03 UTC
Created attachment 109804 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 184 Kyle M Hall 2020-09-09 13:48:07 UTC
Created attachment 109805 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 185 Kyle M Hall 2020-09-09 13:48:12 UTC
Created attachment 109806 [details] [review]
Bug 24857: Copy the volume to the item's enumchron

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 186 Kyle M Hall 2020-09-09 13:48:17 UTC
Created attachment 109807 [details] [review]
Bug 24857: Add user permission for volumes management

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 187 Kyle M Hall 2020-09-09 13:48:23 UTC
Created attachment 109808 [details] [review]
Bug 24857: Fix license statements
Comment 188 Kyle M Hall 2020-09-09 13:48:28 UTC
Created attachment 109809 [details] [review]
Bug 24857: Fix POD
Comment 189 Kyle M Hall 2020-09-09 13:48:33 UTC
Created attachment 109810 [details] [review]
Bug 24857: Add missing filter and move js to footer on additem.tt
Comment 190 Kyle M Hall 2020-09-09 13:48:39 UTC
Created attachment 109811 [details] [review]
Bug 24857: Fix simple-quote string
Comment 191 Kyle M Hall 2020-09-09 13:48:43 UTC
Created attachment 109812 [details] [review]
Bug 24857: Remove doubled 'use Koha::Biblio::Volumes'
Comment 192 Kyle M Hall 2020-09-09 13:48:48 UTC
Created attachment 109813 [details] [review]
Bug 24857: Fix sorting of new syspref
Comment 193 Kyle M Hall 2020-09-09 13:48:53 UTC
Created attachment 109814 [details] [review]
Bug 24857: Change button text from "Create new" to "New volume"
Comment 194 Kyle M Hall 2020-09-09 13:48:58 UTC
Created attachment 109815 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]
Comment 195 Kyle M Hall 2020-09-11 10:27:38 UTC
Created attachment 109894 [details] [review]
Bug 24857: (QA follow-up) Add volume to table settings
Comment 196 Kyle M Hall 2020-09-11 10:53:00 UTC
Created attachment 109901 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 197 Kyle M Hall 2020-09-11 10:53:22 UTC
Created attachment 109902 [details] [review]
Bug 24857: Add new Schema files

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 198 Kyle M Hall 2020-09-11 10:53:31 UTC
Created attachment 109903 [details] [review]
Bug 24857: Add Koha Object(s)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 199 Kyle M Hall 2020-09-11 10:53:38 UTC
Created attachment 109904 [details] [review]
Bug 24857: Add Object Methods

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 200 Kyle M Hall 2020-09-11 10:53:45 UTC
Created attachment 109905 [details] [review]
Bug 24857: API spec

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 201 Kyle M Hall 2020-09-11 10:53:52 UTC
Created attachment 109906 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 202 Kyle M Hall 2020-09-11 10:54:00 UTC
Created attachment 109907 [details] [review]
Bug 24857: Implement volume related controllers

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 203 Kyle M Hall 2020-09-11 10:54:08 UTC
Created attachment 109908 [details] [review]
Bug 24857: Add volume management to detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 204 Kyle M Hall 2020-09-11 10:54:15 UTC
Created attachment 109909 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 205 Kyle M Hall 2020-09-11 10:54:22 UTC
Created attachment 109910 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 206 Kyle M Hall 2020-09-11 10:54:27 UTC
Created attachment 109911 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 207 Kyle M Hall 2020-09-11 10:54:35 UTC
Created attachment 109912 [details] [review]
Bug 24857: Copy the volume to the item's enumchron

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 208 Kyle M Hall 2020-09-11 10:54:40 UTC
Created attachment 109913 [details] [review]
Bug 24857: Add user permission for volumes management

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 209 Kyle M Hall 2020-09-11 10:54:46 UTC
Created attachment 109914 [details] [review]
Bug 24857: Fix license statements
Comment 210 Kyle M Hall 2020-09-11 10:54:52 UTC
Created attachment 109915 [details] [review]
Bug 24857: Fix POD
Comment 211 Kyle M Hall 2020-09-11 10:54:58 UTC
Created attachment 109916 [details] [review]
Bug 24857: Add missing filter and move js to footer on additem.tt
Comment 212 Kyle M Hall 2020-09-11 10:55:11 UTC
Created attachment 109917 [details] [review]
Bug 24857: Fix simple-quote string
Comment 213 Kyle M Hall 2020-09-11 10:55:18 UTC
Created attachment 109918 [details] [review]
Bug 24857: Remove doubled 'use Koha::Biblio::Volumes'
Comment 214 Kyle M Hall 2020-09-11 10:55:26 UTC
Created attachment 109919 [details] [review]
Bug 24857: Fix sorting of new syspref
Comment 215 Kyle M Hall 2020-09-11 10:55:31 UTC
Created attachment 109920 [details] [review]
Bug 24857: Change button text from "Create new" to "New volume"
Comment 216 Kyle M Hall 2020-09-11 10:55:37 UTC
Created attachment 109921 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]
Comment 217 Kyle M Hall 2020-09-11 10:55:44 UTC
Created attachment 109922 [details] [review]
Bug 24857: (QA follow-up) Add volume to table settings
Comment 218 Kyle M Hall 2020-09-11 10:55:54 UTC
Created attachment 109923 [details] [review]
Bug 24857: (QA follow-up) Unit tests
Comment 219 Katrin Fischer 2020-09-12 21:07:45 UTC
Hi Kyle,

tests pass, but there is a db error when you run them:

[2020-09-12 21:06:37.69672] [26709] [debug] POST "/api/v1/biblios/XXX/volumes" (57471cdc)
[2020-09-12 21:06:37.69813] [26709] [debug] Routing to controller "Koha::REST::V1::Auth" and action "under"
[2020-09-12 21:06:37.72833] [26709] [debug] Routing to controller "Koha::REST::V1::Biblios::Volumes" and action "add"
DBIx::Class::Storage::DBI::_dbh_execute(): DBI Exception: DBD::mysql::st execute failed: Cannot add or update a child row: a foreign key constraint fails (`koha_kohadev`.`volumes`, CONSTRAINT `volumes_ibfk_1` FOREIGN KEY (`biblionumber`) REFERENCES `biblio` (`biblionumber`) ON DELETE CASCADE ON UPDATE CASCADE) [for Statement "INSERT INTO `volumes` ( `biblionumber`, `created_on`, `description`, `display_order`, `updated_on`) VALUES ( ?, NOW(), ?, ?, current_timestamp )" with ParamValues: 0=0, 1="Vol 1", 2=1] at /home/vagrant/kohaclone/Koha/Object.pm line 166
[2020-09-12 21:06:37.73397] [26709] [debug] 409 Conflict (0.037233s, 26.858/s)
    ok 5 - POST //jFfMRdUyfmSrbUO5TWioGEhp2HSDQXGSqy01hFdFW0DUU9utfXIyBXUNR:thePassword123@/api/v1/biblios/XXX/volumes
    ok 6 - SWAGGER3.2.1
ok 2 - volumes add() tests

Can you please check?
Comment 220 Kyle M Hall 2020-11-05 19:52:11 UTC
Created attachment 113136 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 221 Kyle M Hall 2020-11-05 19:54:58 UTC
Created attachment 113137 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 222 Kyle M Hall 2020-11-05 19:55:11 UTC
Created attachment 113138 [details] [review]
Bug 24857: Add new Schema files

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 223 Kyle M Hall 2020-11-05 19:55:16 UTC
Created attachment 113139 [details] [review]
Bug 24857: Add Koha Object(s)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 224 Kyle M Hall 2020-11-05 19:55:21 UTC
Created attachment 113140 [details] [review]
Bug 24857: Add Object Methods

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 225 Kyle M Hall 2020-11-05 19:55:26 UTC
Created attachment 113141 [details] [review]
Bug 24857: API spec

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 226 Kyle M Hall 2020-11-05 19:55:31 UTC
Created attachment 113142 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 227 Kyle M Hall 2020-11-05 19:55:36 UTC
Created attachment 113143 [details] [review]
Bug 24857: Implement volume related controllers

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 228 Kyle M Hall 2020-11-05 19:55:41 UTC
Created attachment 113144 [details] [review]
Bug 24857: Add volume management to detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 229 Kyle M Hall 2020-11-05 19:55:45 UTC
Created attachment 113145 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 230 Kyle M Hall 2020-11-05 19:55:51 UTC
Created attachment 113146 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 231 Kyle M Hall 2020-11-05 19:55:55 UTC
Created attachment 113147 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 232 Kyle M Hall 2020-11-05 19:56:00 UTC
Created attachment 113148 [details] [review]
Bug 24857: Copy the volume to the item's enumchron

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 233 Kyle M Hall 2020-11-05 19:56:05 UTC
Created attachment 113149 [details] [review]
Bug 24857: Add user permission for volumes management

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 234 Kyle M Hall 2020-11-05 19:56:09 UTC
Created attachment 113150 [details] [review]
Bug 24857: Fix license statements
Comment 235 Kyle M Hall 2020-11-05 19:56:14 UTC
Created attachment 113151 [details] [review]
Bug 24857: Fix POD
Comment 236 Kyle M Hall 2020-11-05 19:56:18 UTC
Created attachment 113152 [details] [review]
Bug 24857: Add missing filter and move js to footer on additem.tt
Comment 237 Kyle M Hall 2020-11-05 19:56:23 UTC
Created attachment 113153 [details] [review]
Bug 24857: Fix simple-quote string
Comment 238 Kyle M Hall 2020-11-05 19:56:27 UTC
Created attachment 113154 [details] [review]
Bug 24857: Remove doubled 'use Koha::Biblio::Volumes'
Comment 239 Kyle M Hall 2020-11-05 19:56:32 UTC
Created attachment 113155 [details] [review]
Bug 24857: Fix sorting of new syspref
Comment 240 Kyle M Hall 2020-11-05 19:56:36 UTC
Created attachment 113156 [details] [review]
Bug 24857: Change button text from "Create new" to "New volume"
Comment 241 Kyle M Hall 2020-11-05 19:56:41 UTC
Created attachment 113157 [details] [review]
Bug 24857: (QA follow-up) Add volume to table settings
Comment 242 Kyle M Hall 2020-11-05 19:56:45 UTC
Created attachment 113158 [details] [review]
Bug 24857: (QA follow-up) Unit tests
Comment 243 Kyle M Hall 2020-11-05 19:56:51 UTC
Created attachment 113159 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]
Comment 244 Kyle M Hall 2020-11-05 19:56:55 UTC
Created attachment 113160 [details] [review]
Bug 24857: (QA follow-up) Fix unit tests and code for changes in Koha::Item::delete
Comment 245 Kyle M Hall 2020-11-05 20:08:55 UTC
Created attachment 113168 [details] [review]
Bug 24857: Update Database

We have a partner that needs Volume Level Holds.
This is a feature that some ILSs have that allows the creation of volumes at the bibliographic level,
with items being optionally assigned to a given volume. This facilitates the ability to place holds
at a volume level, rather than on a specific item or any available item on a record.

Test Plan:
1) Apply the patches for this bug
2) Run updatedatabase.pl
3) Restart all the things!
4) Enable the new syspref EnableVolumes
5) Browse to detail.pl for a record with items
6) Note the new volumes tab
7) Test creating, editing and deleting volumes
8) On the Holdings tab, select one or more items using the checkboxes
8) Note new selection options for setting a volume for items,
   and for clearing a volume for items.
9) Test adding and clearing the volume set for items

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 246 Kyle M Hall 2020-11-05 20:09:10 UTC
Created attachment 113169 [details] [review]
Bug 24857: Add new Schema files

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 247 Kyle M Hall 2020-11-05 20:09:15 UTC
Created attachment 113170 [details] [review]
Bug 24857: Add Koha Object(s)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 248 Kyle M Hall 2020-11-05 20:09:21 UTC
Created attachment 113171 [details] [review]
Bug 24857: Add Object Methods

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 249 Kyle M Hall 2020-11-05 20:09:26 UTC
Created attachment 113172 [details] [review]
Bug 24857: API spec

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 250 Kyle M Hall 2020-11-05 20:09:30 UTC
Created attachment 113173 [details] [review]
Bug 24857: Koha::Biblio::Volume methods

This patch introduces the following methods:
- add_item
- del_item
- items
- to_api_mapping
- store (overloaded)

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 251 Kyle M Hall 2020-11-05 20:09:35 UTC
Created attachment 113174 [details] [review]
Bug 24857: Implement volume related controllers

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 252 Kyle M Hall 2020-11-05 20:09:40 UTC
Created attachment 113175 [details] [review]
Bug 24857: Add volume management to detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 253 Kyle M Hall 2020-11-05 20:09:45 UTC
Created attachment 113176 [details] [review]
Bug 24857: Add ability to attach newly cataloged items to a volume

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 254 Kyle M Hall 2020-11-05 20:09:50 UTC
Created attachment 113177 [details] [review]
Bug 24857: Add ability to manage item's volumes from detail.pl

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 255 Kyle M Hall 2020-11-05 20:09:54 UTC
Created attachment 113178 [details] [review]
Bug 24857: Delete a volume when the last item on that volume is deleted

Signed-off-by: Andrew Fuerste-Henry <andrew@bywatersolutions.com>

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 256 Kyle M Hall 2020-11-05 20:09:59 UTC
Created attachment 113179 [details] [review]
Bug 24857: Copy the volume to the item's enumchron

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 257 Kyle M Hall 2020-11-05 20:10:03 UTC
Created attachment 113180 [details] [review]
Bug 24857: Add user permission for volumes management

Signed-off-by: Rebecca  Coert <rcoert@arlingtonva.us>
Comment 258 Kyle M Hall 2020-11-05 20:10:08 UTC
Created attachment 113181 [details] [review]
Bug 24857: Fix license statements
Comment 259 Kyle M Hall 2020-11-05 20:10:13 UTC
Created attachment 113182 [details] [review]
Bug 24857: Fix POD
Comment 260 Kyle M Hall 2020-11-05 20:10:17 UTC
Created attachment 113183 [details] [review]
Bug 24857: Add missing filter and move js to footer on additem.tt
Comment 261 Kyle M Hall 2020-11-05 20:10:22 UTC
Created attachment 113184 [details] [review]
Bug 24857: Fix simple-quote string
Comment 262 Kyle M Hall 2020-11-05 20:10:27 UTC
Created attachment 113185 [details] [review]
Bug 24857: Remove doubled 'use Koha::Biblio::Volumes'
Comment 263 Kyle M Hall 2020-11-05 20:10:31 UTC
Created attachment 113186 [details] [review]
Bug 24857: Fix sorting of new syspref
Comment 264 Kyle M Hall 2020-11-05 20:10:36 UTC
Created attachment 113187 [details] [review]
Bug 24857: Change button text from "Create new" to "New volume"
Comment 265 Kyle M Hall 2020-11-05 20:10:41 UTC
Created attachment 113188 [details] [review]
Bug 24857: (QA follow-up) Add volume to table settings
Comment 266 Kyle M Hall 2020-11-05 20:10:46 UTC
Created attachment 113189 [details] [review]
Bug 24857: (QA follow-up) Unit tests
Comment 267 Kyle M Hall 2020-11-05 20:10:50 UTC
Created attachment 113190 [details] [review]
Bug 24857: Update existing Schema files [DO NOT PUSH]
Comment 268 Kyle M Hall 2020-11-05 20:10:55 UTC
Created attachment 113191 [details] [review]
Bug 24857: (QA follow-up) Fix unit tests and code for changes in Koha::Item::delete
Comment 269 Kyle M Hall 2020-11-05 20:11:10 UTC
(In reply to Katrin Fischer from comment #219)
> Hi Kyle,
> 
> tests pass, but there is a db error when you run them:
> 
> [2020-09-12 21:06:37.69672] [26709] [debug] POST
> "/api/v1/biblios/XXX/volumes" (57471cdc)
> [2020-09-12 21:06:37.69813] [26709] [debug] Routing to controller
> "Koha::REST::V1::Auth" and action "under"
> [2020-09-12 21:06:37.72833] [26709] [debug] Routing to controller
> "Koha::REST::V1::Biblios::Volumes" and action "add"
> DBIx::Class::Storage::DBI::_dbh_execute(): DBI Exception: DBD::mysql::st
> execute failed: Cannot add or update a child row: a foreign key constraint
> fails (`koha_kohadev`.`volumes`, CONSTRAINT `volumes_ibfk_1` FOREIGN KEY
> (`biblionumber`) REFERENCES `biblio` (`biblionumber`) ON DELETE CASCADE ON
> UPDATE CASCADE) [for Statement "INSERT INTO `volumes` ( `biblionumber`,
> `created_on`, `description`, `display_order`, `updated_on`) VALUES ( ?,
> NOW(), ?, ?, current_timestamp )" with ParamValues: 0=0, 1="Vol 1", 2=1] at
> /home/vagrant/kohaclone/Koha/Object.pm line 166
> [2020-09-12 21:06:37.73397] [26709] [debug] 409 Conflict (0.037233s,
> 26.858/s)
>     ok 5 - POST
> //jFfMRdUyfmSrbUO5TWioGEhp2HSDQXGSqy01hFdFW0DUU9utfXIyBXUNR:thePassword123@/
> api/v1/biblios/XXX/volumes
>     ok 6 - SWAGGER3.2.1
> ok 2 - volumes add() tests
> 
> Can you please check?

That error is expected, as we are testing adding a volume for an invalid biblionumber.